; 1. TASM umbadd1
; 2. TLINK umbadd1
; 3. EXE2BIN umbadd1.exe
;
;
;
; HIMEM-Erweiterung auf UpperMemoryBlocks fr MSDOS 5.0
;
; c't 8/91, Peter Siering
;
; Aufbau des Anforderungsblockes (nur bentigte Daten)
;
rh              segment at 0
                org     02h
rh_cmd          db      ?       ; Kommando
rh_status       dw      ?       ; Returncode
                org     0eh
rh0_brk_ofs     dw      ?       ; Ofs, wo Treiber endet
rh0_brk_seg     dw      ?       ; Seg
rh              ends
;
; *** der Treiber fr die Installation
;
                org     0h
umbadd          segment public
                assume  cs:umbadd, es:rh, ds:nothing

; *** Standard Parameter fr "Pseudo"-Treiber

next_dev        dd      -1
attribute       dw      0E000h
strategy        dw      strat
interrupt       dw      intr
dev_name        db      'UMBADDXX'

; *** Variablen fr den Treiber-Betrieb

hdrptr  label   word                    ; zur Zwischensicherung
        dw      ?, ?

; *** Zeiger auf Anforderungblock sichern

strat   proc    far                     ; ruft DOS als erstes auf

        mov     [hdrptr], bx            ; Adresse des Anforderung-
        mov     [hdrptr]+ 2, es         ; Buffers sichern
        retf

strat   endp

; *** eigentliche Funktionsbehandlung findet erst hier statt

intr    proc    far                     ; ruft DOS als zweites auf

        push    ax                      ; nur tatschlich verwendete
        push    bx                      ; Register sichern
        push    es
        pushf

        les     bx, dword ptr [hdrptr]  ; Anforderungs-Buffer-
        mov     [bx]. rh0_brk_seg, cs   ; Zeiger holen

        mov     al, es:[bx].rh_cmd      ; Kommando auslesen
        or      al, al                  ; Init?
        jnz     other                   ; Nein
        jmp     inst                    ; Ja, installieren

other:  cmp     al, 16                  ; Legale DOS-Function?
        jbe     short dos               ; Ja, "kann nicht" melden
        mov     ax, 8003h               ; "Unknown Command" melden
        jmp     short exit              ; und Abflug

dos:    xor     ax, ax                  ; "Nicht untersttzt"

exit:   or      ax, 0100h               ; "DoneBit" setzen
        mov     es:[bx].rh_status, ax   ; Return-Code sichern

        popf                            ; Register restaurieren
        pop     es
        pop     bx
        pop     ax
        retf                            ; Zurck zum DOS

intr    endp

; *** Variablen fr die eigentliche Erweiterung

xmsctrl label   word                    ; alter XMS-Einsprungpunkt
        dw      ?, ?

umb     struc                           ; fr bergabe der
start   dw      ?                       ; Position und Lnge
len     dw      ?                       ; der einzelnen UMBs
umb     ends                            ; an die Erweiterung

;
; VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
;
; *** Hier sind also die jeweiligen RAM-Bereiche einzutragen
; *** auch mehrere Blcke mglich, letzter immer < 0, 0> !!! 
;			    800h=32K
;			   1000h=64K
;               < Start , Gre>
free    umb     < 0E000h, 01000h>
        umb     < 0, 0>
;
; ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;

; *** Request Upper Memory Block

req     proc    near

        push    ds                      ; Nur bentigte...
        push    si
        push    cx
        push    bx

        push    cs                      ; DS setzen
        pop     ds

        mov     si, offset free         ; Anfang der UMB-Table
        xor     cx, cx                  ; fr Grenermittlung
        xchg    dx, cx                  ; Vergleichsgre in CX

search: lodsw                           ; Startsegment holen
        or      ax, ax                  ; Ende der UMB-Liste?
        jz      fini                    ; Ja, Abflug
        mov     bx, ax                  ; Segment in BX merken
        lodsw                           ; Lnge holen
        cmp     bx, 0ffffh              ; Block vergeben?
        je      search                  ; Ja, nchsten probieren
        cmp     dx, ax                  ; Grer als bisher Grter?
        jae     szchk                   ; Nein
        mov     dx, ax                  ; Ja, Gre merken

szchk:  cmp     cx, ax                  ; Gengt Gre?
        ja      search                  ; Nein, nchsten probieren

        ; Block gefunden

        mov     [si- 4], 0ffffh         ; Als vergeben markieren
        mov     dx, ax                  ; Gre des Blocks in DX
        mov     ax, 1                   ; Erfolg signalisieren
        pop     cx                      ; BX enhlt Segment
        jmp     short return            ; Abflug

fini:   xor     ax, ax                  ; Kein passender UMB da
        or      dx, dx                  ; Wengstens etwas gefunden?
        jnz     sizeerr                 ; Ja, nur zu klein
        pop     bx                      ; BH soll heil bleiben
        mov     bl, 0b1h                ; Keine UMBs mehr da
        jmp     short return            ; signalisieren

sizeerr:pop     bx                      ; BH heillassen
        mov     bl, 0b0h                ; Kleinerer wre verfgbar

return: pop     cx                      ; Register reparieren
        pop     si
        pop     ds
        popf
        retf                            ; zurck

req     endp

; *** Neuer XMS-UMB-Handler (implementiert nur "request UMB")

        assume  es:nothing, ds:nothing

newxms: jmp     short hcsave            ; HookChain nachbilden
        nop
        nop
        nop

hcsave: pushf                           ; gehen kaputt
        cmp     ah, 010h                ; Request-Funktion?
        je      req                     ; Ja, ausfhren
        popf                            ; sonst altem Handler
        jmp     dword ptr cs:[xmsctrl]  ; berlassen

; *** Installationsroutinen (nicht resident)

        assume  ds:umbadd, es:rh

error:  mov     ah, 09h                 ; Fehlermeldung
        int     21h                     ; ausgeben
        les     bx, dword ptr [hdrptr]  ; Treiber nicht
        xor     ax, ax                  ; installieren
        mov     es:[bx]. rh0_brk_ofs, ax
        jmp     dexit                   ; Abflug

; *** hier geht's los

inst:   push    cx                      ; restliche Register sichern
        push    dx
        push    si
        push    di
        push    ds

        push    cs                      ; Datensegment setzen
        pop     ds

        mov     dx, offset hello$       ; "Guten Tag"
        mov     ah, 09h
        int     21h

        mov     ax, 04300h              ; HIMEM berhaupt da?
        int     2fh
        cmp     al, 080h
        je      gethc                   ; Ja, weiter

        mov     dx, offset noxms$       ; Sonst abbrechen
        jmp     short error

gethc:  mov     ax, 04310h              ; XMS-Aufrufadresse
        int     2fh                     ; ermitteln
        mov     [xmsctrl], bx           ; und sichern
        mov     [xmsctrl+ 2], es

        mov     ah, 010h                ; Testen, ob UMB-Funktionen
        mov     dx, 0ffffh              ; schon bedient werden
        call    dword ptr [xmsctrl]
        cmp     bl, 080h                ; Nicht installiert?
        jz      ramtst                  ; Gut, dann RAM testen

        mov     dx, offset oops$        ; Sonst abbrechen
        jmp     error

ramtst: ; Liegt in den angegebenen Bereichen tatschlich RAM?


; ======================================================================


        mov     si, offset free         ; Anfang des ersten UMBs
        cld                             ; Strg Operationen

nxtumb: lodsw                           ; Segment holen
        or      ax, ax                  ; Ende der UMBs?
        jz      addumb                  ; Erweiterung anhngen
        mov     es, ax                  ; Segment sichern
        lodsw                           ; Gre holen
        mov     cl, 0ah                 ; durch 2^10 teilen
        shr     ax, cl                  ; ergibt Anzahl 16K-Blcke

tstit:  xor     di, di                  ; Offset der Testadresse
        mov     bx, es:[di]             ; Speicherzelle auslesen
        mov     dx, bx
        xor     dx, 0ffffh              ; Gegenteil davon erzeugen
        mov     es:[di], dx             ; und wegschreiben
        mov     cx, 080h                ; Ein Weilchen warten, damit
        loop    $                       ; wir nicht geschriebenes lesen
        cmp     es:[di], dx             ; Noch gleich?
        mov     es:[di], bx             ; restaurieren
        jnz     ramerr                  ; Ungleich, Fehler melden


        dec     ax                      ; Blockanzahl eins runter
        jz      nxtumb                  ; Ende erreicht...
        mov     di, es
        add     di, 0400h               ; in 16K-Schritten
        mov     es, di
nxt16:  jmp     short tstit


ramerr: mov     dx, offset noram$       ; Fehlermeldung
        mov     ah, 09h
        int     21h

        mov     dx, es                  ; Segment anzeigen, in dem
        mov     di, offset noramp$
        push    cs
        pop     es
        mov     bx, offset digs
        mov     ax, dx                  ; Segment holen
        xchg    al, ah                  ; Erst High-Byte
        call    makehex
        mov     ax, dx
        call    makehex

        mov     dx, offset noramp$
        jmp     error

makehex proc    near

        db      0d4h, 10h               ; AAM auf 16er-Basis
        xchg    al, ah                  ; erst High-Nibble

        xlat
        stosb                           ; Ascii sichern
        xchg    al, ah
        xlat
        stosb
        ret

digs    db      '0123456789ABCDEF'

makehex endp

addumb: ; HookChain bis zum Ende durchlaufen

        les     di, dword ptr [xmsctrl] ; AnfangsPtr laden

testhc: cmp     byte ptr es:[di], 0ebh  ; steht dort JMP short?
        je      hcend                   ; Ja, Ende erreicht
        cmp     byte ptr es:[di], 0eah  ; Zur Sicherheit: JMP far?
        je      hcnext                  ; Ja, weitersuchen
        mov     dx, offset hcerr$       ; HookChain im Eimer
        jmp     error                   ; abbrechen

hcnext: les     di, es:[di+ 1]          ; Sprungziel auslesen
        jmp     short testhc            ; dort weitersuchen

hcend:  mov     [xmsctrl], di           ; Ofs sichern
        add     [xmsctrl], 5            ; 'echter' Entry
        mov     [xmsctrl+ 2], es        ; Segment sichern

        mov     byte ptr es:[di], 0eah  ; JMP far einfrickeln
        mov     es:[di+ 3], cs          ; ebenso Seg & Ofs
        mov     word ptr es:[di+ 1], offset newxms

        mov     dx, offset instok$      ; Erfolgsmeldung ausgeben
        mov     ah, 09h
        int     21h

        mov     ax, offset error        ; Lnge des Treibers ans
        les     bx, dword ptr [hdrptr]  ; DOS via Anforderungs-
        mov     es:[bx].rh0_brk_ofs, ax ; Block bergeben
        xor     ax, ax                  ; Erfolg signalisieren

dexit:  pop     ds                      ; Register restaurieren
        pop     di
        pop     si
        pop     dx
        pop     cx
        jmp     exit                    ; Treiber-Exit

hello$  db      13,10,"UMB-Addon-Device, c't 8/91 (ps)"
	db	13,10,'ohne Chipsatz-Programmierung:  E000-EFFF',13,10,'$'
noxms$  db      13,10,'Kein XMS-Treiber vorhanden. '
        db      'Erweiterung kann nicht vorgenommen werden',13,10,7,'$'
oops$   db      13,10,'XMS-Treiber untersttzt bereits UMBs.',13,10,7,'$'
hcerr$  db      13,10,'HookChain beschdigt oder inkompatibel.',13,10,7,'$'
instok$ db      13,10,'UMB Erweiterung erfolgreich installiert',13,10,'$'
noram$  db      13,10,7,'Kein RAM an Adresse $'
noramp$ db      'xxxx gefunden.',13,10,'$'


indexport	dw	?
datenport	dw	?
maske		db	?
index		db	?
wert		db	?

umbadd          ends
                end
